/**
 * LOGICAL-PARADOX.ORG variable record manager library
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 * Release 1.0
 * Ep[W
 */
package org.logical_paradox.common.vrm;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.logical_paradox.common.io.MemoryMappedRandomAccessFile;
import org.logical_paradox.common.vrm.VRMAvailableList;

/**
 * Ŏs\VRMAvailableList
 * eXgp̎
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version 1.0
 */
public class VRMAvailableListMoc extends VRMAvailableList {
	private MemoryMappedRandomAccessFile file = new MemoryMappedRandomAccessFile();

	public VRMAvailableListMoc(String filename) {
		super(filename);
	}
	public VRMAvailableListMoc(String filename, int size) {
		super(filename, size);
	}
	// o̓Xg[Ԃ
	protected OutputStream getOutputStream() throws IOException {
		// o̓Xg[JƂɁCVt@Cpӂ
		// ㏑G~[V邽
		file = new MemoryMappedRandomAccessFile();
		return file.getOutputStream();
	}
	// ̓Xg[Ԃ
	protected InputStream getInputStream() throws IOException {
		if(file == null) {
			file = new MemoryMappedRandomAccessFile();
		}
		file.seek(0);
		return file.getInputStream();
	}
	/**
	 * fЉt@C̃t@CTCYԂ
	 * @return t@CTCY
	 * @throws IOException fЉt@CɃANZXłȂ
	 */
	protected long getFileSize() throws IOException {
		return file == null ? 0 : file.length();
	}
}
